<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!--
    cuckoo web authoring
    cuckoo-xspForPrinters.xsl
    Transformation used on PageBox site
    Version 0.01
    Copyright (c) 2000-2001 Alexis Grandemange
    Mail: alexis.grandemange@pagebox.net
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; version
    2.1 of the License.
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.
    A copy of the GNU Lesser General Public License lesser.txt should be
    included in the distribution.
  --> 
<xsl:output indent='no'/>
<xsl:variable name="page" select="cuckoo/page"/>
<xsl:template match="cuckoo">
    <html>
    <head>
    <xsl:copy-of select="info"/>
    <link rel="stylesheet" href="cuckoo.css" type="text/css"/>
    <script src="cuckoo.js"></script>
    </head>
    <body>
    <div id="tooltip" style="position:absolute;visibility:hidden;border:1px solid black;font-size:small;layer-background-color:#ffffaa;color:black;background:#ffffaa;padding:1px">
    </div>
    <xsl:copy>
        <xsl:apply-templates select="document('pagebox-xsp.xml')/site/header"/>
    </xsl:copy>
    <p> </p>
    <p style="font-size:large;font-family:Verdana;color:#336699;"><xsl:value-of select="info/title"/></p>
    <xsl:copy-of select="toc"/>
    <p> </p>
    <xsl:copy-of select="content"/>
    <p align="center">
    <xsl:copy-of select="document('pagebox-xsp.xml')/site/footer"/>
    </p>
    </body></html>
</xsl:template>
<xsl:template match="line">
    <table width="100%"><tr>
    <xsl:apply-templates select="node()"/>
    </tr></table>
</xsl:template>
<xsl:template match="field">
    <td>
    <xsl:copy-of select="node()"/>
    </td>
</xsl:template>
<xsl:template match="table">
    <xsl:copy-of select="."/>
</xsl:template>
<xsl:template match="field-link">
    <td><font class="seek">
    <xsl:apply-templates select="node()"/>
    </font></td>
</xsl:template>
<xsl:template match="a">
    <xsl:copy-of select="."/>
</xsl:template>
<xsl:template match="link">
    <xsl:choose>
    <xsl:when test='@href="Word"'>
        <a href='{$page}-doc.zip'>
        <xsl:apply-templates select='node()'/>
        </a>
    </xsl:when>
    </xsl:choose>
</xsl:template>
<xsl:template match="img">
    <xsl:copy-of select="."/>
</xsl:template>
</xsl:stylesheet>